import * as ec2 from 'aws-cdk-lib/aws-ec2';
import { Construct } from 'constructs';
export interface VpcProps {
    readonly name: string;
    readonly cidr: string;
    readonly azs: string[];
    readonly publicSubnets: string[];
    readonly privateSubnets: string[];
    readonly databaseSubnets?: string[];
    readonly enableKubernenetes?: boolean;
    readonly kubernetesClusterName?: string;
}
export declare class VpcPattern extends Construct {
    private natGateways;
    vpcId: ec2.IVpc;
    privateSubnets: ec2.ISubnet[];
    publicSubnets: ec2.ISubnet[];
    databaseSubnets: ec2.ISubnet[];
    constructor(scope: Construct, id: string, props: VpcProps);
}
